import * as E from "fp-ts/lib/Either";
import * as ET from "fp-ts/lib/EitherT";
import { fromEitherK, } from "fp-ts/lib/FromEither";
import { pipe } from "fp-ts/lib/function";
import { tap } from "./internal";
/** @internal */
export function tapEither(F, M) {
    const fromEither = fromEitherK(F);
    const tapM = tap(M);
    return (self, f) => tapM(self, fromEither(f));
}
/** @internal */
export function mapBoth(F) {
    return (self, f, g) => F.map(self, E.bimap(f, g));
}
/** @internal */
export function mapError(F) {
    return (self, f) => F.map(self, E.mapLeft(f));
}
/** @internal */
export function flatMap(M) {
    return (ma, f) => M.chain(ma, (e) => (E.isLeft(e) ? M.of(e) : f(e.right)));
}
/** @internal */
export function tapError(M) {
    const orElseM = ET.orElse(M);
    return (ma, onLeft) => pipe(ma, orElseM((e) => M.map(onLeft(e), (eb) => (E.isLeft(eb) ? eb : E.left(e)))));
}
