/**
 * @since 1.0.0
 */
import * as O from "fp-ts/lib/Option";
import * as T from "fp-ts/lib/Task";
/**
 * @category sequencing
 * @since 1.0.0
 */
export declare function getAsyncIteratorNextTask<A>(iterable: AsyncIterable<A>): T.Task<O.Option<A>>;
/**
 * generic async iterable reducer.
 *
 * - limit: how many values pull in parallel.
 * - until: predicate if the function should keep pulling values from the iterator
 * - b: reducer accumulator initial value.
 * - f: reducer function.
 *
 * @category sequencing
 * @since 1.0.0
 */
export declare function reduceUntilWithIndexLimited<A, B>(limit: number, until: (a: A) => boolean, b: B, f: (i: number, b: B, a: A) => B): (iterable: AsyncIterable<A>) => T.Task<B>;
